package com.btcpiyush.ads.google_applovin_unity_ads.image_loader

import android.content.Context
import android.graphics.drawable.Drawable
import android.view.View
import android.widget.ImageView
import kotlin.jvm.JvmOverloads
import android.widget.ProgressBar
import com.bumptech.glide.Glide
import com.bumptech.glide.load.DataSource
import com.bumptech.glide.request.RequestListener
import com.bumptech.glide.load.engine.GlideException

class ImageLoadGlide {
    @JvmOverloads
    fun imageLoad(
        src_image: String?, imageView: ImageView?,
        activity: Context?, imageLoad: ImageLoad, progressBar: ProgressBar? = null
    ) {
        progressBar?.visibility = View.VISIBLE

        Glide.with(activity!!)
            .load(src_image).listener(object : RequestListener<Drawable?> {
                override fun onLoadFailed(
                    e: GlideException?,
                    model: Any,
                    target:  com.bumptech.glide.request.target.Target<Drawable?>,
                    isFirstResource: Boolean
                ): Boolean {
                    //on load failed
                    progressBar?.visibility = View.GONE
                    imageLoad.onLoadFailed(e, model, target, isFirstResource)
                    return false
                }

                override fun onResourceReady(
                    resource: Drawable?,
                    model: Any,
                    target:  com.bumptech.glide.request.target.Target<Drawable?>,
                    dataSource: DataSource,
                    isFirstResource: Boolean
                ): Boolean {
                    //on load success
                    progressBar?.visibility = View.GONE
                    imageLoad.onSuccess(resource, model, target, dataSource, isFirstResource)
                    return false
                }
            }).into(imageView!!)
    }

    interface ImageLoad {
        fun onLoadFailed(
            e: GlideException?,
            model: Any?,
            target:  com.bumptech.glide.request.target.Target<Drawable?>?,
            isFirstResource: Boolean
        )

        fun onSuccess(
            resource: Drawable?,
            model: Any?,
            target:  com.bumptech.glide.request.target.Target<Drawable?>?,
            dataSource: DataSource?,
            isFirstResource: Boolean
        )
    }
}