package com.btcpiyush.ads.google_applovin_unity_ads.native_ad

import android.annotation.SuppressLint
import android.app.Activity
import android.content.Context
import android.content.Intent
import android.content.res.Resources
import android.graphics.Color
import android.graphics.drawable.ColorDrawable
import android.graphics.drawable.Drawable
import android.net.Uri
import android.util.Log
import android.view.LayoutInflater
import android.view.View
import android.widget.FrameLayout
/*import com.appharbr.sdk.engine.AdSdk
import com.appharbr.sdk.engine.AdStateResult
import com.appharbr.sdk.engine.AppHarbr*/
import com.applovin.mediation.MaxAd
import com.applovin.mediation.MaxAdRevenueListener
import com.applovin.mediation.MaxError
import com.applovin.mediation.nativeAds.MaxNativeAdListener
import com.applovin.mediation.nativeAds.MaxNativeAdLoader
import com.applovin.mediation.nativeAds.MaxNativeAdView
import com.applovin.mediation.nativeAds.MaxNativeAdViewBinder
import com.bumptech.glide.load.DataSource
import com.bumptech.glide.load.engine.GlideException
import com.bumptech.glide.request.target.Target
import com.facebook.ads.*
import com.facebook.ads.AdError
import com.google.android.gms.ads.*
import com.google.android.gms.ads.AdListener
import com.google.android.gms.ads.nativead.NativeAdOptions
import com.btcpiyush.ads.google_applovin_unity_ads.R
import com.btcpiyush.ads.google_applovin_unity_ads.RequestFactory
import com.btcpiyush.ads.google_applovin_unity_ads.api.AppSettings
import com.btcpiyush.ads.google_applovin_unity_ads.api.GoogleAdsSetting
import com.btcpiyush.ads.google_applovin_unity_ads.databinding.*
import com.btcpiyush.ads.google_applovin_unity_ads.image_loader.ImageLoadGlide
import com.google.gson.Gson
import io.flutter.plugin.common.MethodChannel
import io.flutter.plugin.common.StandardMessageCodec
import io.flutter.plugin.platform.PlatformView
import io.flutter.plugin.platform.PlatformViewFactory
import java.util.*


data class NativeAdViewFactory(val activity: Activity, val settings: AppSettings) :
    PlatformViewFactory(StandardMessageCodec.INSTANCE) {

    init {
        Log.e("MainActivity", "NativeAdViewFactory Init")
    }

    override fun create(context: Context?, viewId: Int, args: Any?): PlatformView {
        val creationParams = args as Map<String?, Any?>?
        Log.e("create: ", " ---- " + creationParams.toString())
        context?.let {
            return loadNativeAd(context, settings, creationParams)
        }
        return DefaultClass(activity)
    }
}

private fun loadNativeAd(
    context: Context,
    it: AppSettings,
    creationParams: Map<String?, Any?>?,
    pos: Int = 0
): PlatformView {
    Log.e("loadNativeAd  : ", " Init ------- ${creationParams.toString()}")


    if (it.adsSequence.size > 0 && it.adsSequence.size > pos) {
        Log.e("loadNativeAd  : ", " Init ------- ${it.adsSequence[pos].lowercase()}")
        when (it.adsSequence[pos].lowercase()) {
            context.getString(R.string.google_ads).lowercase() -> {
                Log.e(
                    "loadNativeAd  : ",
                    " it.googleAds?.isNativeAds ------- ${it.googleAds?.isNativeAds}     it.googleAds?.nativeId ->   ${it.googleAds?.nativeId}"
                )
                val googleNativeID = if (it.googleAds?.isNativeAds == true) {
                    it.googleAds?.nativeId
                } else {
                    null
                }

                if (googleNativeID.isNullOrEmpty()) {
                    return loadNativeAd(
                        context,
                        it,
                        creationParams,
                        pos + 1
                    )
                }

                return AbmobNativeAdView(context, it, googleNativeID, creationParams, pos)
            }

            context.getString(R.string.facebook_ads).lowercase() -> {

                creationParams?.let { data ->
                    val banner_size = data["banner_size"].toString()
                    when (banner_size) {
                        "F" -> {
                            val facebookNativeID = if (it.facebookAds?.isNativeAds == true) {
                                it.facebookAds?.nativeId
                            } else {
                                null
                            }

                            if (!facebookNativeID.isNullOrEmpty()) {
                                return FacebookNativeAdView(
                                    context,
                                    it,
                                    facebookNativeID,
                                    creationParams,
                                    pos
                                )
                            }
                        }

                    }
                }

                return loadNativeAd(
                    context,
                    it,
                    creationParams,
                    pos + 1
                )
            }

            context.getString(R.string.app_lovin).lowercase() -> {

                val appLovinNativeID = if (it.appLovin?.isNativeAds == true) {
                    it.appLovin?.appLovinNativeID?.manualNativeId
                        ?: (it.appLovin?.appLovinNativeID?.smallNativeId
                            ?: it.appLovin?.appLovinNativeID?.mediumNativeId)
                } else {
                    null
                }

                Log.e(
                    "loadNativeAd  : ",
                    " it.appLovin?.isNativeAds ------- ${it.appLovin?.isNativeAds}     it.googleAds?.nativeId ->   ${appLovinNativeID}"
                )

                if (appLovinNativeID.isNullOrEmpty()) {
                    return loadNativeAd(
                        context,
                        it,
                        creationParams,
                        pos + 1
                    )
                }

                return AppLovinNativeAdView(
                    context,
                    it,
                    appLovinNativeID,
                    creationParams,
                    pos
                )
            }

            context.getString(R.string.custom_ads).lowercase() -> {
                Log.e("loadNativeAd  : ", " customAds ------- ")

                it.customAds?.qurakaNativeImage?.let { images ->
                    Log.e("loadNativeAd  : ", " images ------- ${images.size}")
                    if (images.size > 0 && it.customAds?.isNativeAds == true) {
                        var random_index = Random().nextInt(images.size)

                        if (random_index >= images.size) {
                            random_index = images.size - 1
                        }

                        Log.e("loadNativeAd  : ", " random_index ------- ${random_index}")

                        val nativeUrl = images[random_index]

                        Log.e("loadNativeAd  : ", " nativeUrl ------- ${nativeUrl} ")

                        if (!nativeUrl.isNullOrEmpty()) {
                            return CustomNativeAdView(context, it, nativeUrl, creationParams, pos)
                        }

                    }
                }

                return loadNativeAd(context, it, creationParams, pos + 1)
            }
            else -> {
                return loadNativeAd(context, it, creationParams, pos + 1)
            }
        }
    } else {
        return DefaultClass(context)
    }
}

data class AbmobNativeAdView(
    val context: Context,
    val it: AppSettings,
    val nativeId: String,
    val data: Map<String?, Any?>?,
    val pos: Int
) : PlatformView {

    private var controller: NativeAdController =
        NativeAdControllerManager.getController(data!!["controllerId"] as String)!!

    init {
        try {
            Log.e("TAG", "Google Ads: ${Gson().toJson(data)}")
        } catch (e: Exception) { }

        if (controller.nativeAdView == null) {
            controller.nativeAdView = FrameLayout(context)
        }
        controller.loadRequested = { load(it) }
        load(null)
    }

    fun dpToPx(dp: Int): Int {
        return (dp * Resources.getSystem().displayMetrics.density).toInt()
    }

    private fun getStyle(
        button_back_color: String,
        button_text_color: String
    ): NativeTemplateStyle {
        return NativeTemplateStyle.Builder().withCallToActionBackgroundColor(
            ColorDrawable(Color.parseColor(button_back_color))
        ).withCallToActionTypefaceColor(Color.parseColor(button_text_color)).build()
    }

    private fun createFullNativeAdView(
        button_back_color: String,
        button_text_color: String
    ): TemplateView {
        val templateView = NativeFullAdmobBinding.inflate(LayoutInflater.from(context)).root
        templateView.setStyles(getStyle(button_back_color, button_text_color))
        return templateView
    }

    private fun createMediumNativeAdView(
        button_back_color: String,
        button_text_color: String
    ): TemplateView {
        val templateView = NativeMediumAdmobBinding.inflate(LayoutInflater.from(context)).root
        templateView.setStyles(getStyle(button_back_color, button_text_color))
        return templateView
    }

    private fun createSmallNativeAdView(
        button_back_color: String,
        button_text_color: String
    ): TemplateView {
        val templateView = NativeSmallAdmobBinding.inflate(LayoutInflater.from(context)).root
        templateView.setStyles(getStyle(button_back_color, button_text_color))
        return templateView
    }

    @SuppressLint("MissingPermission")
    private fun load(result: MethodChannel.Result?) {
        Log.e("TAG", "load:  method call -- Google ADs")
        data?.let { data ->

            val button_back_color = data["button_back_color"].toString()
            val button_text_color = data["button_text_color"].toString()

            var customAdView = createFullNativeAdView(button_back_color, button_text_color)

            val banner_size = data["banner_size"].toString()
            when (banner_size) {
                "S" -> {
                    customAdView = createSmallNativeAdView(button_back_color, button_text_color)
                }

                "M" -> {
                    customAdView = createMediumNativeAdView(button_back_color, button_text_color)
                }
            }


            val adOptions = NativeAdOptions.Builder()
                .setRequestCustomMuteThisAd(true)
            val adVideoOptions = VideoOptions.Builder()
                .setStartMuted(true)
            adOptions.setVideoOptions(adVideoOptions.build())

            AdLoader.Builder(context, nativeId)
                .forNativeAd { nativeAd ->
                    controller.nativeAd = nativeAd
                    /*if (it.adSetting?.isGeoSDKFlag == true && (it.adSetting?.geoSDKKey
                            ?: "").isNotEmpty()
                    ) {
                        val adResult = AppHarbr.shouldBlockNativeAd(AdSdk.ADMOB, nativeAd)
                        Log.e("onAdLoaded: ", " ----  " + Gson().toJson(adResult))
                        if (adResult.adStateResult != AdStateResult.BLOCKED) {
                            customAdView.setNativeAd(nativeAd)
                        } else {
                            dispose()
                            try {
                                controller.nativeAdView?.addView(
                                    loadNativeAd(
                                        context,
                                        it,
                                        data,
                                        pos
                                    ).view
                                )
                            } catch (e: Exception) {
                            }
                        }
                    } else {*/
                    customAdView.setNativeAd(nativeAd)
                    /*}*/
                }
                .withNativeAdOptions(adOptions.build())
                .withAdListener(object : AdListener() {
                    override fun onAdFailedToLoad(error: LoadAdError) {
                        super.onAdFailedToLoad(error)
                        /* channel.invokeMethod("onAdFailedToLoad", encodeError(error))
                        result.success(false)*/
                        dispose()
                        try {
                            //controller.nativeAdView?.addView(
                                loadNativeAd (
                                    context,
                                    it, data, pos + 1
                                ).view as FrameLayout
                            //)
                        } catch (e: Exception) { }
                    }

                    override fun onAdLoaded() {
                        super.onAdLoaded()
                        // controller?.nativeAdChanged?.let { it(controller?.nativeAd) }

                        Log.e("AppLovinNtvAdView  : ", " dispose ------- ")

                        try {
                            if ((controller.nativeAdView?.childCount ?: 0) > 0) {
                                controller.nativeAdView?.removeAllViews()
                            }
                        } catch (e: Exception) { }

                        try {
                            controller.nativeAdView?.removeAllViewsInLayout()
                        } catch (e: Exception) { }

                        controller.nativeAdView?.addView(customAdView)
                        controller.channel.invokeMethod("onAdLoaded", customAdView.height)
                        result?.success(true)
                    }
                }).build().loadAd(RequestFactory.createAdRequest(false, emptyList()))
        }
    }

    override fun getView(): View {
        Log.e("AppLovinNtvAdView  : ", " getView ------- ")
        return controller.nativeAdView!!
    }

    override fun dispose() {
        Log.e("AppLovinNtvAdView  : ", " dispose ------- ")

        try {
            if ((controller.nativeAdView?.childCount ?: 0) > 0) {
                controller.nativeAdView?.removeAllViews()
            }
        } catch (e: Exception) { }

        try {
            controller.nativeAdView?.removeAllViewsInLayout()
        } catch (e: Exception) { }

        try {
            controller.nativeAd?.destroy()
        } catch (e: Exception) { }
    }

}

data class AppLovinNativeAdView(
    val context: Context,
    val it: AppSettings,
    val nativeId: String,
    val data: Map<String?, Any?>?,
    val pos: Int
) : PlatformView, MaxAdRevenueListener {

    private var controller: NativeAdController =
        NativeAdControllerManager.getController(data!!["controllerId"] as String)!!
    private var appLovinNativeAdView: MaxNativeAdLoader? = null

    init {
//        Log.e("AppLovinNtvAdView  : ", " Init ------- ${Gson().toJson(data)}")
        if (controller.nativeAdView == null) {
            controller.nativeAdView = FrameLayout(context)
        }
        controller.loadRequested = { load(it) }
        load(null)
    }

    fun dpToPx(dp: Int): Int {
        return (dp * Resources.getSystem().displayMetrics.density).toInt()
    }

    private fun createFullNativeAdView(): MaxNativeAdView {
            val binder: MaxNativeAdViewBinder =
                MaxNativeAdViewBinder.Builder(R.layout.native_full_template)
                    .setTitleTextViewId(R.id.primary)
                    .setBodyTextViewId(R.id.body_text)
                    .setAdvertiserTextViewId(R.id.body)
                    .setIconImageViewId(R.id.icon)
                    .setMediaContentViewGroupId(R.id.media_view)
//                .setOptionsContentViewGroupId(R.id.native_outline_shape)
                    .setCallToActionButtonId(R.id.cta)
                    .build()
            return MaxNativeAdView(binder, context)
    }

    private fun createMediumNativeAdView(): MaxNativeAdView {
        val binder: MaxNativeAdViewBinder =
            MaxNativeAdViewBinder.Builder(R.layout.native_medium_template)
                .setTitleTextViewId(R.id.primary)
                .setBodyTextViewId(R.id.secondary)
                .setAdvertiserTextViewId(R.id.body)
                .setIconImageViewId(R.id.icon)
                .setCallToActionButtonId(R.id.cta)
                .build()
        return MaxNativeAdView(binder, context)
    }

    private fun createSmallNativeAdView(): MaxNativeAdView {
        val binder: MaxNativeAdViewBinder =
            MaxNativeAdViewBinder.Builder(R.layout.native_small_template)
                .setTitleTextViewId(R.id.primary)
                .setBodyTextViewId(R.id.body)
                .setIconImageViewId(R.id.icon)
                .setCallToActionButtonId(R.id.cta)
                .build()

        return MaxNativeAdView(binder, context)
    }

    private fun setStyle(
        customAdView: MaxNativeAdView,
        button_back_color: String,
        button_text_color: String
    ) {
        customAdView.callToActionButton.setBackgroundColor(Color.parseColor(button_back_color))
        customAdView.callToActionButton.setTextColor(Color.parseColor(button_text_color))
    }

    private fun load(result: MethodChannel.Result?) {
        Log.e("AppLovinNtvAdView  : ", " load -------    $nativeId")
        appLovinNativeAdView = MaxNativeAdLoader(nativeId,  controller.appLovinSDK, context)
        var customAdView = createFullNativeAdView()
        data?.let { data ->

            val banner_size = data["banner_size"].toString()

            when (banner_size) {
                "S" -> {
                    customAdView = createSmallNativeAdView()
                }

                "M" -> {
                    customAdView = createMediumNativeAdView()
                }
            }

            val button_back_color = data["button_back_color"].toString()
            val button_text_color = data["button_text_color"].toString()

            setStyle(customAdView, button_back_color, button_text_color)

            /*val height: Int = dpToPx((data["size_height"] as Double).toInt())
            val param = ConstraintLayout.LayoutParams(
                ConstraintLayout.LayoutParams.MATCH_PARENT,
                height
            )
            customAdView.mainView.layoutParams = param*/
        }
        // appLovinNativeAdView?.setRevenueListener(this)
        appLovinNativeAdView?.setNativeAdListener(object : MaxNativeAdListener() {
            override fun onNativeAdLoaded(nativeAdView: MaxNativeAdView?, ad: MaxAd?) {
                super.onNativeAdLoaded(nativeAdView, ad)
                Log.e("Applovin", "onNativeAdLoaded:  ---     ")

                // Clean up any pre-existing native ad to prevent memory leaks.
                dispose()

                controller.appLovinNativeAd = ad
                controller.appLovinNativeAdView = nativeAdView
                controller.nativeAdView?.addView(controller.appLovinNativeAdView)
                controller.channel.invokeMethod(
                    "onAdLoaded",
                    customAdView.height
                )
                result?.success(true)
            }

            override fun onNativeAdLoadFailed(p0: String?, p1: MaxError?) {
                super.onNativeAdLoadFailed(p0, p1)
                Log.e("Applovin", "onNativeAdLoadFailed: -------   ")

                dispose()

                try {//controller.nativeAdView?.addView(
                    loadNativeAd(
                        context,
                        it,
                        data,
                        pos + 1
                    ).view
                    //)
                } catch (e: Exception) {
                }

                /* controller?.channel?.invokeMethod("onAdFailedToLoad", encodeError(p1))
                 result.success(false)*/
            }

            override fun onNativeAdClicked(p0: MaxAd?) {
                super.onNativeAdClicked(p0)
            }
        })
        appLovinNativeAdView?.loadAd(customAdView)
    }

    override fun getView(): View {
        Log.e("AppLovinNtvAdView  : ", " getView ------- ")
        return controller.nativeAdView!!
    }

    override fun dispose() {
        Log.e("AppLovinNtvAdView  : ", " dispose ------- ")
        try {
            if (controller.appLovinNativeAd != null) {
                appLovinNativeAdView?.destroy(controller.appLovinNativeAd)
            }
        } catch (e: Exception) {
        }

        try {
            if ((controller.nativeAdView?.childCount ?: 0) > 0) {
                controller.nativeAdView?.removeAllViews()
            }
        } catch (e: Exception) {
        }

        try {
            controller.nativeAdView?.removeAllViewsInLayout()
        } catch (e: Exception) {
        }

    }

    override fun onAdRevenuePaid(ad: MaxAd?) {

    }
}

data class CustomNativeAdView(
    val context: Context,
    val it: AppSettings,
    val nativeUrl: String,
    val data: Map<String?, Any?>?,
    val pos: Int
) : PlatformView {

    private var controller: NativeAdController =
        NativeAdControllerManager.getController(data!!["controllerId"] as String)!!
    val customAdView = createFullNativeAdView()

    init {
//        Log.e("TAG", "Custom Ads: ${Gson().toJson(data)}")
        if (controller.nativeAdView == null) {
            controller.nativeAdView = FrameLayout(context)
        }
        dispose()
        controller.nativeAdView?.addView(customAdView.root)
        controller.loadRequested = { load(it) }
        load(null)
    }

    private fun createFullNativeAdView(): NativeCustomAdsBinding {
        return NativeCustomAdsBinding.inflate(LayoutInflater.from(context))
    }

    private fun load(result: MethodChannel.Result?) {
        Log.e("TAG", "load:  method call -- Custom ads  $nativeUrl")

        ImageLoadGlide().imageLoad(
            nativeUrl,
            customAdView.ivNativeImage,
            context,
            object : ImageLoadGlide.ImageLoad {
                override fun onLoadFailed(
                    e: GlideException?,
                    model: Any?,
                    target: Target<Drawable?>?,
                    isFirstResource: Boolean
                ) {
                    Log.e("onLoadFailed: ", " ------Custom Ads ----- " + e?.message.toString())
                    dispose()
                    try {
//                        controller.nativeAdView?.addView(
                            loadNativeAd(
                                context,
                                it,
                                data,
                                pos + 1
                            ).view
//                        )
                    } catch (e: Exception) {
                    }
                }

                override fun onSuccess(
                    resource: Drawable?,
                    model: Any?,
                    target: Target<Drawable?>?,
                    dataSource: DataSource?,
                    isFirstResource: Boolean
                ) {
                    controller.channel.invokeMethod(
                        "onAdLoaded",
                        controller.nativeAdView?.height ?: 0
                    )
                    result?.success(true)
                    Log.e("onSuccess: ", " ------Custim Ads ----- ")
                }

            },
            customAdView.progressbar
        )

        customAdView.root.setOnClickListener {
            openPage()
        }

        dispose()
        controller.nativeAdView?.addView(customAdView.root)
    }

    private fun openPage() {
        it.customAds?.qurekaLink?.let {
            try {
                val browserIntent = Intent(Intent.ACTION_VIEW, Uri.parse(it))
                browserIntent.setPackage("com.android.chrome")
                context.startActivity(browserIntent)
            } catch (e: Exception) {
                try {
                    val browserIntent =
                        Intent(Intent.ACTION_VIEW, Uri.parse(it))
                    context.startActivity(browserIntent)
                } catch (e: Exception) { }
            }
        }
    }

    override fun getView(): View {
        Log.e("Custom Ads  : ", " getView ------- ")
        return controller.nativeAdView!!
    }

    override fun dispose() {
        Log.e("Custom Ads  : ", " dispose ------- ")

        try {
            if ((controller.nativeAdView?.childCount ?: 0) > 0) {
                controller.nativeAdView?.removeAllViews()
            }
        } catch (e: Exception) {
        }

        try {
            controller.nativeAdView?.removeAllViewsInLayout()
        } catch (e: Exception) {
        }
    }

}

data class FacebookNativeAdView(
    val context: Context,
    val it: AppSettings,
    val nativeId: String,
    val data: Map<String?, Any?>?,
    val pos: Int
) : PlatformView {

    private var controller: NativeAdController =
        NativeAdControllerManager.getController(data!!["controllerId"] as String)!!
    private val customAdView = createFullNativeAdView()
    private val customAdLayoutView = createFullNativeAdLayoutView()

    init {
//        Log.e("TAG", "Facebook Ads: ${Gson().toJson(data)}")
        if (controller.nativeAdView == null) {
            controller.nativeAdView = FrameLayout(context)
        }
        controller.loadRequested = { load(it) }
        load(null)
    }

    fun dpToPx(dp: Int): Int {
        return (dp * Resources.getSystem().displayMetrics.density).toInt()
    }

    private fun createFullNativeAdView(): NativeFacebookAdsBinding {
        return NativeFacebookAdsBinding.inflate(LayoutInflater.from(context))
    }

    private fun createFullNativeAdLayoutView(): NativeFacebookAdsLayoutBinding {
        return NativeFacebookAdsLayoutBinding.inflate(LayoutInflater.from(context))
    }

    private fun load(result: MethodChannel.Result?) {
        Log.e("TAG", "load:  method call -- Facebook ADs")
        data?.let { data ->
            val button_back_color = data["button_back_color"].toString()
            val button_text_color = data["button_text_color"].toString()
            customAdView.nativeAdCallToAction.setBackgroundColor(Color.parseColor(button_back_color))
            customAdView.nativeAdCallToAction.setTextColor(Color.parseColor(button_text_color))
        }

        controller.nativeAdFacebook = NativeAd(context, nativeId)
        val nativeAdListener = object : NativeAdListener {
            override fun onError(p0: Ad?, p1: AdError?) {
                dispose()
                Log.e(
                    "TAG",
                    "onError --   Facebook AD   ${p1?.errorCode}   " + p1?.errorMessage.toString()
                )
                try {
                    //controller.nativeAdView?.addView(
                        loadNativeAd(
                            context,
                            it,
                            data,
                            pos + 1
                        ).view
                    //)
                } catch (e: Exception) {
                }
            }

            override fun onAdLoaded(p0: Ad?) {
                Log.e("TAG", "onAdLoaded -- Facebook ADs ")
                if (controller.nativeAdFacebook == null || controller.nativeAdFacebook != p0) {
                    return
                }
                inflateAd(controller.nativeAdFacebook!!)
                controller.channel.invokeMethod(
                    "onAdLoaded",
                    customAdLayoutView.root.height
                )
                result?.success(true)
            }

            override fun onAdClicked(p0: Ad?) {}

            override fun onLoggingImpression(p0: Ad?) {}

            override fun onMediaDownloaded(p0: Ad?) {}

        }

        try {
            if ((controller.nativeAdView?.childCount ?: 0) > 0) {
                controller.nativeAdView?.removeAllViews()
            }
        } catch (e: Exception) {
        }

        try {
            controller.nativeAdView?.removeAllViewsInLayout()
        } catch (e: Exception) {
        }

        controller.nativeAdView?.addView(customAdLayoutView.root)

        // Request an ad
        controller.nativeAdFacebook?.loadAd(
            controller.nativeAdFacebook?.buildLoadAdConfig()
                ?.withAdListener(nativeAdListener)
                ?.build()
        )
    }

    private fun inflateAd(nativeAd: NativeAd) {
        nativeAd.unregisterView()
        if (controller.nativeAdView == null) {
            controller.nativeAdView = FrameLayout(context)
        }

        val nativeAdLayout = customAdLayoutView.nativeAdContainer
        val adView = customAdView.root
        try {
            try {
                nativeAdLayout.removeAllViews()
            } catch (e: Exception) {
                e.printStackTrace()
            } finally {
                nativeAdLayout.addView(adView)
            }
        } catch (e: Exception) {
            e.printStackTrace()
        }

        val adChoicesContainer = customAdView.adChoicesContainer
        val adOptionsView = AdOptionsView(context, nativeAd, nativeAdLayout)
        try {
            try {
                adChoicesContainer.removeAllViews()
            } catch (e: Exception) {
                e.printStackTrace()
            } finally {
                adChoicesContainer.addView(adOptionsView, 0)
            }
        } catch (e: Exception) {
            e.printStackTrace()
        }


        // Set the Text.
        customAdView.nativeAdTitle.text = nativeAd.advertiserName
        customAdView.nativeAdBody.text = nativeAd.adBodyText
        customAdView.nativeAdSocialContext.text = nativeAd.adSocialContext
        customAdView.nativeAdCallToAction.visibility =
            if (nativeAd.hasCallToAction()) View.VISIBLE else View.INVISIBLE
        customAdView.nativeAdCallToAction.text = nativeAd.adCallToAction
        customAdView.nativeAdSponsoredLabel.text = nativeAd.sponsoredTranslation

        // Create a list of clickable views
        val clickableViews: MutableList<View> = ArrayList()
        clickableViews.add(customAdView.nativeAdTitle)
        clickableViews.add(customAdView.nativeAdCallToAction)

        // Register the Title and CTA button to listen for clicks.
        nativeAd.registerViewForInteraction(
            adView, customAdView.nativeAdMedia, customAdView.nativeAdIcon, clickableViews
        )
    }

    override fun getView(): View {
        Log.e("AppLovinNtvAdView  : ", " getView ------- ")
        return controller.nativeAdView!!
    }

    override fun dispose() {
        Log.e("AppLovinNtvAdView  : ", " dispose ------- ")

        try {
            if ((controller.nativeAdView?.childCount ?: 0) > 0) {
                controller.nativeAdView?.removeAllViews()
            }
        } catch (e: Exception) {
        }

        try {
            controller.nativeAdView?.removeAllViewsInLayout()
        } catch (e: Exception) {
        }

        try {
            controller.nativeAdView?.removeViewAt(0)
        } catch (e: Exception) {
        }

        try {
            controller.nativeAdFacebook?.unregisterView()
        } catch (e: Exception) {
        }
    }

}

data class DefaultClass(val context: Context) : PlatformView {

    override fun getView(): View {
        return FrameLayout(context)
    }

    override fun dispose() {}

}