import 'dart:async';

import 'package:flutter/services.dart';
import 'package:google_applovin_unity_ads/interestial/admob_events.dart';


abstract class AdmobEventHandler {
  final Function(AdmobAdEvent, Map<String, dynamic>?)? _listener;

  AdmobEventHandler(Function(AdmobAdEvent, Map<String, dynamic>?)? listener)
      : _listener = listener;

  Future<void> handleEvent(MethodCall call) async {

    if (_listener == null) {
      return;
    }

    switch (call.method) {
      case 'success':
      case 'SUCCESS':
        _listener!(AdmobAdEvent.success, null);
        break;
      case 'error':
      case 'ERROR':
        _listener!(AdmobAdEvent.error,
            Map<String, dynamic>.from(call.arguments));
        break;
    }
  }
}
